<?php

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';


include_once 'propel/util/Criteria.php';

include_once 'classes/model/TriggersPeer.php';

/**
 * Base class that represents a row from the 'TRIGGERS' table.
 *
 * 
 *
 * @package    workflow.classes.model.om
 */
abstract class BaseTriggers extends BaseObject implements Persistent
{

    /**
     * The Peer class.
     * Instance provides a convenient way of calling static methods on a class
     * that calling code may not be able to identify.
     * @var        TriggersPeer
    */
    protected static $peer;

    /**
     * The value for the tri_uid field.
     * @var        string
     */
    protected $tri_uid = '';

    /**
     * The value for the tri_title field.
     * @var        string
     */
    protected $tri_title;

    /**
     * The value for the tri_description field.
     * @var        string
     */
    protected $tri_description;

    /**
     * The value for the pro_uid field.
     * @var        string
     */
    protected $pro_uid = '';

    /**
     * The value for the tri_type field.
     * @var        string
     */
    protected $tri_type = 'SCRIPT';

    /**
     * The value for the tri_webbot field.
     * @var        string
     */
    protected $tri_webbot;

    /**
     * The value for the tri_param field.
     * @var        string
     */
    protected $tri_param;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInSave = false;

    /**
     * Flag to prevent endless validation loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInValidation = false;

    /**
     * Get the [tri_uid] column value.
     * 
     * @return     string
     */
    public function getTriUid()
    {

        return $this->tri_uid;
    }

    /**
     * Get the [tri_title] column value.
     * 
     * @return     string
     */
    public function getTriTitle()
    {

        return $this->tri_title;
    }

    /**
     * Get the [tri_description] column value.
     * 
     * @return     string
     */
    public function getTriDescription()
    {

        return $this->tri_description;
    }

    /**
     * Get the [pro_uid] column value.
     * 
     * @return     string
     */
    public function getProUid()
    {

        return $this->pro_uid;
    }

    /**
     * Get the [tri_type] column value.
     * 
     * @return     string
     */
    public function getTriType()
    {

        return $this->tri_type;
    }

    /**
     * Get the [tri_webbot] column value.
     * 
     * @return     string
     */
    public function getTriWebbot()
    {

        return $this->tri_webbot;
    }

    /**
     * Get the [tri_param] column value.
     * 
     * @return     string
     */
    public function getTriParam()
    {

        return $this->tri_param;
    }

    /**
     * Set the value of [tri_uid] column.
     * 
     * @param      string $v new value
     * @return     void
     */
    public function setTriUid($v)
    {

        // Since the native PHP type for this column is string,
        // we will cast the input to a string (if it is not).
        if ($v !== null && !is_string($v)) {
            $v = (string) $v;
        }

        if ($this->tri_uid !== $v || $v === '') {
            $this->tri_uid = $v;
            $this->modifiedColumns[] = TriggersPeer::TRI_UID;
        }

    } // setTriUid()

    /**
     * Set the value of [tri_title] column.
     * 
     * @param      string $v new value
     * @return     void
     */
    public function setTriTitle($v)
    {

        // Since the native PHP type for this column is string,
        // we will cast the input to a string (if it is not).
        if ($v !== null && !is_string($v)) {
            $v = (string) $v;
        }

        if ($this->tri_title !== $v) {
            $this->tri_title = $v;
            $this->modifiedColumns[] = TriggersPeer::TRI_TITLE;
        }

    } // setTriTitle()

    /**
     * Set the value of [tri_description] column.
     * 
     * @param      string $v new value
     * @return     void
     */
    public function setTriDescription($v)
    {

        // Since the native PHP type for this column is string,
        // we will cast the input to a string (if it is not).
        if ($v !== null && !is_string($v)) {
            $v = (string) $v;
        }

        if ($this->tri_description !== $v) {
            $this->tri_description = $v;
            $this->modifiedColumns[] = TriggersPeer::TRI_DESCRIPTION;
        }

    } // setTriDescription()

    /**
     * Set the value of [pro_uid] column.
     * 
     * @param      string $v new value
     * @return     void
     */
    public function setProUid($v)
    {

        // Since the native PHP type for this column is string,
        // we will cast the input to a string (if it is not).
        if ($v !== null && !is_string($v)) {
            $v = (string) $v;
        }

        if ($this->pro_uid !== $v || $v === '') {
            $this->pro_uid = $v;
            $this->modifiedColumns[] = TriggersPeer::PRO_UID;
        }

    } // setProUid()

    /**
     * Set the value of [tri_type] column.
     * 
     * @param      string $v new value
     * @return     void
     */
    public function setTriType($v)
    {

        // Since the native PHP type for this column is string,
        // we will cast the input to a string (if it is not).
        if ($v !== null && !is_string($v)) {
            $v = (string) $v;
        }

        if ($this->tri_type !== $v || $v === 'SCRIPT') {
            $this->tri_type = $v;
            $this->modifiedColumns[] = TriggersPeer::TRI_TYPE;
        }

    } // setTriType()

    /**
     * Set the value of [tri_webbot] column.
     * 
     * @param      string $v new value
     * @return     void
     */
    public function setTriWebbot($v)
    {

        // Since the native PHP type for this column is string,
        // we will cast the input to a string (if it is not).
        if ($v !== null && !is_string($v)) {
            $v = (string) $v;
        }

        if ($this->tri_webbot !== $v) {
            $this->tri_webbot = $v;
            $this->modifiedColumns[] = TriggersPeer::TRI_WEBBOT;
        }

    } // setTriWebbot()

    /**
     * Set the value of [tri_param] column.
     * 
     * @param      string $v new value
     * @return     void
     */
    public function setTriParam($v)
    {

        // Since the native PHP type for this column is string,
        // we will cast the input to a string (if it is not).
        if ($v !== null && !is_string($v)) {
            $v = (string) $v;
        }

        if ($this->tri_param !== $v) {
            $this->tri_param = $v;
            $this->modifiedColumns[] = TriggersPeer::TRI_PARAM;
        }

    } // setTriParam()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (1-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param      ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
     * @param      int $startcol 1-based offset column which indicates which restultset column to start with.
     * @return     int next starting column
     * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate(ResultSet $rs, $startcol = 1)
    {
        try {

            $this->tri_uid = $rs->getString($startcol + 0);

            $this->tri_title = $rs->getString($startcol + 1);

            $this->tri_description = $rs->getString($startcol + 2);

            $this->pro_uid = $rs->getString($startcol + 3);

            $this->tri_type = $rs->getString($startcol + 4);

            $this->tri_webbot = $rs->getString($startcol + 5);

            $this->tri_param = $rs->getString($startcol + 6);

            $this->resetModified();

            $this->setNew(false);

            // FIXME - using NUM_COLUMNS may be clearer.
            return $startcol + 7; // 7 = TriggersPeer::NUM_COLUMNS - TriggersPeer::NUM_LAZY_LOAD_COLUMNS).

        } catch (Exception $e) {
            throw new PropelException("Error populating Triggers object", $e);
        }
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param      Connection $con
     * @return     void
     * @throws     PropelException
     * @see        BaseObject::setDeleted()
     * @see        BaseObject::isDeleted()
     */
    public function delete($con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(TriggersPeer::DATABASE_NAME);
        }

        try {
            $con->begin();
            TriggersPeer::doDelete($this, $con);
            $this->setDeleted(true);
            $con->commit();
        } catch (PropelException $e) {
            $con->rollback();
            throw $e;
        }
    }

    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.  This method
     * wraps the doSave() worker method in a transaction.
     *
     * @param      Connection $con
     * @return     int The number of rows affected by this insert/update
     * @throws     PropelException
     * @see        doSave()
     */
    public function save($con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(TriggersPeer::DATABASE_NAME);
        }

        try {
            $con->begin();
            $affectedRows = $this->doSave($con);
            $con->commit();
            return $affectedRows;
        } catch (PropelException $e) {
            $con->rollback();
            throw $e;
        }
    }

    /**
     * Stores the object in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param      Connection $con
     * @return     int The number of rows affected by this insert/update and any referring
     * @throws     PropelException
     * @see        save()
     */
    protected function doSave($con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;


            // If this object has been modified, then save it to the database.
            if ($this->isModified()) {
                if ($this->isNew()) {
                    $pk = TriggersPeer::doInsert($this, $con);
                    $affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
                                         // should always be true here (even though technically
                                         // BasePeer::doInsert() can insert multiple rows).

                    $this->setNew(false);
                } else {
                    $affectedRows += TriggersPeer::doUpdate($this, $con);
                }
                $this->resetModified(); // [HL] After being saved an object is no longer 'modified'
            }

            $this->alreadyInSave = false;
        }
        return $affectedRows;
    } // doSave()

    /**
     * Array of ValidationFailed objects.
     * @var        array ValidationFailed[]
     */
    protected $validationFailures = array();

    /**
     * Gets any ValidationFailed objects that resulted from last call to validate().
     *
     *
     * @return     array ValidationFailed[]
     * @see        validate()
     */
    public function getValidationFailures()
    {
        return $this->validationFailures;
    }

    /**
     * Validates the objects modified field values and all objects related to this table.
     *
     * If $columns is either a column name or an array of column names
     * only those columns are validated.
     *
     * @param      mixed $columns Column name or an array of column names.
     * @return     boolean Whether all columns pass validation.
     * @see        doValidate()
     * @see        getValidationFailures()
     */
    public function validate($columns = null)
    {
        $res = $this->doValidate($columns);
        if ($res === true) {
            $this->validationFailures = array();
            return true;
        } else {
            $this->validationFailures = $res;
            return false;
        }
    }

    /**
     * This function performs the validation work for complex object models.
     *
     * In addition to checking the current object, all related objects will
     * also be validated.  If all pass then <code>true</code> is returned; otherwise
     * an aggreagated array of ValidationFailed objects will be returned.
     *
     * @param      array $columns Array of column names to validate.
     * @return     mixed <code>true</code> if all validations pass; 
                   array of <code>ValidationFailed</code> objects otherwise.
     */
    protected function doValidate($columns = null)
    {
        if (!$this->alreadyInValidation) {
            $this->alreadyInValidation = true;
            $retval = null;

            $failureMap = array();


            if (($retval = TriggersPeer::doValidate($this, $columns)) !== true) {
                $failureMap = array_merge($failureMap, $retval);
            }



            $this->alreadyInValidation = false;
        }

        return (!empty($failureMap) ? $failureMap : true);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param      string $name name
     * @param      string $type The type of fieldname the $name is of:
     *                     one of the class type constants TYPE_PHPNAME,
     *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
     * @return     mixed Value of field.
     */
    public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = TriggersPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
        return $this->getByPosition($pos);
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param      int $pos position in xml schema
     * @return     mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch($pos) {
            case 0:
                return $this->getTriUid();
                break;
            case 1:
                return $this->getTriTitle();
                break;
            case 2:
                return $this->getTriDescription();
                break;
            case 3:
                return $this->getProUid();
                break;
            case 4:
                return $this->getTriType();
                break;
            case 5:
                return $this->getTriWebbot();
                break;
            case 6:
                return $this->getTriParam();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param      string $keyType One of the class type constants TYPE_PHPNAME,
     *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
     * @return     an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = BasePeer::TYPE_PHPNAME)
    {
        $keys = TriggersPeer::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getTriUid(),
            $keys[1] => $this->getTriTitle(),
            $keys[2] => $this->getTriDescription(),
            $keys[3] => $this->getProUid(),
            $keys[4] => $this->getTriType(),
            $keys[5] => $this->getTriWebbot(),
            $keys[6] => $this->getTriParam(),
        );
        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param      string $name peer name
     * @param      mixed $value field value
     * @param      string $type The type of fieldname the $name is of:
     *                     one of the class type constants TYPE_PHPNAME,
     *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
     * @return     void
     */
    public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = TriggersPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
        return $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param      int $pos position in xml schema
     * @param      mixed $value field value
     * @return     void
     */
    public function setByPosition($pos, $value)
    {
        switch($pos) {
            case 0:
                $this->setTriUid($value);
                break;
            case 1:
                $this->setTriTitle($value);
                break;
            case 2:
                $this->setTriDescription($value);
                break;
            case 3:
                $this->setProUid($value);
                break;
            case 4:
                $this->setTriType($value);
                break;
            case 5:
                $this->setTriWebbot($value);
                break;
            case 6:
                $this->setTriParam($value);
                break;
        } // switch()
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
     * TYPE_NUM. The default key type is the column's phpname (e.g. 'authorId')
     *
     * @param      array  $arr     An array to populate the object from.
     * @param      string $keyType The type of keys the array uses.
     * @return     void
     */
    public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
    {
        $keys = TriggersPeer::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) {
            $this->setTriUid($arr[$keys[0]]);
        }

        if (array_key_exists($keys[1], $arr)) {
            $this->setTriTitle($arr[$keys[1]]);
        }

        if (array_key_exists($keys[2], $arr)) {
            $this->setTriDescription($arr[$keys[2]]);
        }

        if (array_key_exists($keys[3], $arr)) {
            $this->setProUid($arr[$keys[3]]);
        }

        if (array_key_exists($keys[4], $arr)) {
            $this->setTriType($arr[$keys[4]]);
        }

        if (array_key_exists($keys[5], $arr)) {
            $this->setTriWebbot($arr[$keys[5]]);
        }

        if (array_key_exists($keys[6], $arr)) {
            $this->setTriParam($arr[$keys[6]]);
        }

    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return     Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(TriggersPeer::DATABASE_NAME);

        if ($this->isColumnModified(TriggersPeer::TRI_UID)) {
            $criteria->add(TriggersPeer::TRI_UID, $this->tri_uid);
        }

        if ($this->isColumnModified(TriggersPeer::TRI_TITLE)) {
            $criteria->add(TriggersPeer::TRI_TITLE, $this->tri_title);
        }

        if ($this->isColumnModified(TriggersPeer::TRI_DESCRIPTION)) {
            $criteria->add(TriggersPeer::TRI_DESCRIPTION, $this->tri_description);
        }

        if ($this->isColumnModified(TriggersPeer::PRO_UID)) {
            $criteria->add(TriggersPeer::PRO_UID, $this->pro_uid);
        }

        if ($this->isColumnModified(TriggersPeer::TRI_TYPE)) {
            $criteria->add(TriggersPeer::TRI_TYPE, $this->tri_type);
        }

        if ($this->isColumnModified(TriggersPeer::TRI_WEBBOT)) {
            $criteria->add(TriggersPeer::TRI_WEBBOT, $this->tri_webbot);
        }

        if ($this->isColumnModified(TriggersPeer::TRI_PARAM)) {
            $criteria->add(TriggersPeer::TRI_PARAM, $this->tri_param);
        }


        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @return     Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = new Criteria(TriggersPeer::DATABASE_NAME);

        $criteria->add(TriggersPeer::TRI_UID, $this->tri_uid);

        return $criteria;
    }

    /**
     * Returns the primary key for this object (row).
     * @return     string
     */
    public function getPrimaryKey()
    {
        return $this->getTriUid();
    }

    /**
     * Generic method to set the primary key (tri_uid column).
     *
     * @param      string $key Primary key.
     * @return     void
     */
    public function setPrimaryKey($key)
    {
        $this->setTriUid($key);
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param      object $copyObj An object of Triggers (or compatible) type.
     * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @throws     PropelException
     */
    public function copyInto($copyObj, $deepCopy = false)
    {

        $copyObj->setTriTitle($this->tri_title);

        $copyObj->setTriDescription($this->tri_description);

        $copyObj->setProUid($this->pro_uid);

        $copyObj->setTriType($this->tri_type);

        $copyObj->setTriWebbot($this->tri_webbot);

        $copyObj->setTriParam($this->tri_param);


        $copyObj->setNew(true);

        $copyObj->setTriUid(''); // this is a pkey column, so set to default value

    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return     Triggers Clone of current object.
     * @throws     PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);
        return $copyObj;
    }

    /**
     * Returns a peer instance associated with this om.
     *
     * Since Peer classes are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     *
     * @return     TriggersPeer
     */
    public function getPeer()
    {
        if (self::$peer === null) {
            self::$peer = new TriggersPeer();
        }
        return self::$peer;
    }
}

